iTerrainFactoryCell Struct Reference (Crystal Space 2.0 Public API Reference)

| ## Public API Reference

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions
iTerrainFactoryCell Struct Reference

Factory representation of a cell. More...

`#include <imesh/terrain2.h>`

Inheritance diagram for iTerrainFactoryCell:

List of all members.

## Public Member Functions
virtual iMaterialWrapper * | GetAlphaSplatMaterial () const =0
| Get the optional alpha-splat material for the cell.
virtual iMaterialWrapper * | GetBaseMaterial () const =0
| Get base material for the cell.
virtual iTerrainCellCollisionProperties * | GetCollisionProperties () const =0
| Get cell collision properties.
virtual iTerrainCellFeederProperties * | GetFeederProperties () const =0
| Get cell feeder properties.
virtual int | GetGridHeight () const =0
| Get grid height.
virtual int | GetGridWidth () const =0
| Get grid width.
virtual int | GetMaterialMapHeight () const =0
| Get material map height (essentially a height of both material array and material masks, if any).
virtual int | GetMaterialMapWidth () const =0
| Get material map width (essentially a width of both material array and material masks, if any).
virtual bool | GetMaterialPersistent () const =0
| Get material persistent flag.
virtual const char * | GetName ()=0
| Get name of this cell.
virtual const csVector2 & | GetPosition () const =0
| Get cell position (in object space).
virtual iTerrainCellRenderProperties * | GetRenderProperties () const =0
| Get cell rendering properties.
virtual const csVector3 & | GetSize () const =0
| Get cell size (in object space).
virtual iMaterialWrapper * | GetSplatBaseMaterial () const =0
| Get splat base material for the cell.
virtual void | SetAlphaSplatMaterial (iMaterialWrapper *material)=0
| Set the optional alpha-splat material for the cell.
virtual void | SetBaseMaterial (iMaterialWrapper *material)=0
| Set base material for the cell.
virtual void | SetGridHeight (int h)=0
| Set grid height.
virtual void | SetGridWidth (int w)=0
| Set grid width.
virtual void | SetMaterialMapHeight (int h)=0
| Set material map height (essentially a height of both material array and material masks, if any).
virtual void | SetMaterialMapWidth (int w)=0
| Set material map width (essentially a width of both material array and material masks, if any).
virtual void | SetMaterialPersistent (bool flag)=0
| Set material persistent flag.
virtual void | SetName (const char *name)=0
| Set name of this cell.
virtual void | SetPosition (const csVector2 &pos)=0
| Set cell position (in object space).
virtual void | SetSize (const csVector3 &size)=0
| Set cell size (in object space).
virtual void | SetSplatBaseMaterial (iMaterialWrapper *material)=0
| Set optional splat base material for the cell.

## Detailed Description

Factory representation of a cell.

Definition at line 1415 of file terrain2.h.

## Member Function Documentation

virtual iMaterialWrapper* iTerrainFactoryCell::GetAlphaSplatMaterial | ( |  | ) | const`[pure virtual]`

Get the optional alpha-splat material for the cell.

Returns:
  nullptr if no material, else the material.

virtual iMaterialWrapper* iTerrainFactoryCell::GetBaseMaterial | ( |  | ) | const`[pure virtual]`

Get base material for the cell.

virtual iTerrainCellCollisionProperties* iTerrainFactoryCell::GetCollisionProperties | ( |  | ) | const`[pure virtual]`

Get cell collision properties.

Returns pointer to a collider-specific class, though it is possible to check/change some general properties.

Returns:
  cell collision properties

virtual iTerrainCellFeederProperties* iTerrainFactoryCell::GetFeederProperties | ( |  | ) | const`[pure virtual]`

Get cell feeder properties.

Returns pointer to a feeder-specific class though it is possible to check/change some general properties.

Returns:
  cell feeder properties

virtual int iTerrainFactoryCell::GetGridHeight | ( |  | ) | const`[pure virtual]`

Get grid height.

It is the height of an array of height data. You can expect it to be 2^n + 1 (note: it is equal to grid width)

Returns:
  grid height

virtual int iTerrainFactoryCell::GetGridWidth | ( |  | ) | const`[pure virtual]`

Get grid width.

It is the width of an array of height data. You can expect it to be 2^n + 1.

Returns:
  grid width

virtual int iTerrainFactoryCell::GetMaterialMapHeight | ( |  | ) | const`[pure virtual]`

Get material map height (essentially a height of both material array and material masks, if any).

Returns:
  material map height

virtual int iTerrainFactoryCell::GetMaterialMapWidth | ( |  | ) | const`[pure virtual]`

Get material map width (essentially a width of both material array and material masks, if any).

Returns:
  material map width

virtual bool iTerrainFactoryCell::GetMaterialPersistent | ( |  | ) | const`[pure virtual]`

Get material persistent flag.

If it is true, material data is stored in the cell (that makes updating material data faster and makes material data lock read/write, but it means larger memory overhead)

virtual const char* iTerrainFactoryCell::GetName | ( |  | ) | `[pure virtual]`

Get name of this cell.

virtual const csVector2& iTerrainFactoryCell::GetPosition | ( |  | ) | const`[pure virtual]`

Get cell position (in object space).

X and Y components specify the offsets along X and Z axes, respectively.

Returns:
  cell position

virtual iTerrainCellRenderProperties* iTerrainFactoryCell::GetRenderProperties | ( |  | ) | const`[pure virtual]`

Get cell rendering properties.

Returns pointer to a renderer-specific class, though it is possible to check/change some general properties.

Returns:
  cell rendering properties

virtual const csVector3& iTerrainFactoryCell::GetSize | ( |  | ) | const`[pure virtual]`

Get cell size (in object space).

X and Y components specify the sizes along X and Z axes, respectively. Z component specifies height scale (warning: it is used only at loading stage, after that all scales are in object space).

Returns:
  cell size

virtual iMaterialWrapper* iTerrainFactoryCell::GetSplatBaseMaterial | ( |  | ) | const`[pure virtual]`

Get splat base material for the cell.

virtual void iTerrainFactoryCell::SetAlphaSplatMaterial | ( | iMaterialWrapper * | material | ) | `[pure virtual]`

Set the optional alpha-splat material for the cell.

Parameters:

  material | material handle of the alpha-splat material.

virtual void iTerrainFactoryCell::SetBaseMaterial | ( | iMaterialWrapper * | material | ) | `[pure virtual]`

Set base material for the cell.

Parameters:

  material | material handle of base material.

virtual void iTerrainFactoryCell::SetGridHeight | ( | int | h | ) | `[pure virtual]`

Set grid height.

It will be changed to match the grid width requirements`- equal to grid width.

virtual void iTerrainFactoryCell::SetGridWidth | ( | int | w | ) | `[pure virtual]`

Set grid width.

It will be changed to match the grid width requirements`- it will be 2^n + 1.

virtual void iTerrainFactoryCell::SetMaterialMapHeight | ( | int | h | ) | `[pure virtual]`

Set material map height (essentially a height of both material array and material masks, if any).

virtual void iTerrainFactoryCell::SetMaterialMapWidth | ( | int | w | ) | `[pure virtual]`

Set material map width (essentially a width of both material array and material masks, if any).

virtual void iTerrainFactoryCell::SetMaterialPersistent | ( | bool | flag | ) | `[pure virtual]`

Set material persistent flag.

See also:
  GetMaterialPersistent

virtual void iTerrainFactoryCell::SetName | ( | const char * | name | ) | `[pure virtual]`

Set name of this cell.

virtual void iTerrainFactoryCell::SetPosition | ( | const csVector2 & | pos | ) | `[pure virtual]`

Set cell position (in object space).

X and Y components specify the offsets along X and Z axes, respectively.

virtual void iTerrainFactoryCell::SetSize | ( | const csVector3 & | size | ) | `[pure virtual]`

Set cell size (in object space).

X and Y components specify the sizes along X and Z axes, respectively. Z component specifies height scale (warning: it is used only at loading stage, after that all scales are in object space).

virtual void iTerrainFactoryCell::SetSplatBaseMaterial | ( | iMaterialWrapper * | material | ) | `[pure virtual]`

Set optional splat base material for the cell.

The splat base material is rendered before splatting or alpha-splatting is rendered for the cell.

Parameters:

  material | material handle of spalt base material.

The documentation for this struct was generated from the following file:

- imesh/terrain2.h